program IC_Tester;
Uses CRT;
Const BA = $3F8;                           { COM 1 }
var Dout, Din, Ain : Byte;
    Testfile: File of Byte;

procedure Austausch;
var Stelle, StelleAD, n, m  : Integer;
begin
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                       { Verzgerung }
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  StelleAD := 128;
  Din := 0;
  Ain := 0;
  for n:=1 to 8 do begin
    if ((Dout AND Stelle) > 0) then
      Port [BA+3] := 64                     { Daten ausgeben (TXD) }
      else Port [BA+3] := 0;
    if (Port[BA+6] AND 128) = 128           { Daten lesen (DCD) }
       then Din := Din + Stelle;
    if (Port[BA+6] AND 32) = 32 then        { A/D lesen (DSR) }
       Ain := Ain + StelleAD;
    Port [Ba+4] := 1;                       { Clock an (DTR) }
    Stelle := Stelle * 2;
    StelleAD := StelleAD div 2;
    Port [BA+4] := 0;                       { Clock aus (DTR) }
  end;
  Port [BA+4] := 2;                         { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA+4] := 0;                         { Strobe aus (RTS) }
end;

procedure NeueDatei;
begin
  Assign(Testfile,'CD4011.TST');
  {$I-} Rewrite(Testfile); {$I+}
  for Dout := 0 to 255 do begin
    Austausch;
    Austausch;
    writeln (Dout,'  ',Din,'  ',Ain);
    write (Testfile,Din);
  end;
  Close (Testfile);
end;

procedure ICtest;
var Vergleich: Byte;
    OK : Boolean;
begin
  Assign(Testfile,'CD4011.TST');
  {$I-} Reset(Testfile); {$I+}
  OK := true;
  for Dout := 0 to 255 do begin
    Austausch;
    delay (20);
    Austausch;
    writeln (Dout,'  ',Din,'  ',Ain);
    read (Testfile,Vergleich);
    if Din <> Vergleich then OK := false;
    delay (20);
  end;
  Close (Testfile);
  writeln;
  If OK then writeln ('IC ist OK')
    else writeln ('Fehler gefunden');
  writeln;
end;

begin
  { NeueDatei; }
  ICtest;
end.
